diff --git a/src/Fl_File_Chooser2.cxx b/src/Fl_File_Chooser2.cxx
index bddae82..3a7c093 100644
--- a/src/Fl_File_Chooser2.cxx
+++ b/src/Fl_File_Chooser2.cxx
@@ -1665,18 +1665,22 @@ quote_pathname(char       *dst,		// O - Destination string
                const char *src,		// I - Source string
 	       int        dstsize)	// I - Size of destination string
 {
-  dstsize --;
+  dstsize--; // prepare for trailing zero
 
   while (*src && dstsize > 1) {
     if (*src == '\\') {
       // Convert backslash to forward slash...
       *dst++ = '\\';
       *dst++ = '/';
+      dstsize -= 2;
       src ++;
     } else {
-      if (*src == '/') *dst++ = '\\';
-
+      if (*src == '/') {
+	*dst++ = '\\';
+	dstsize--;
+      }
       *dst++ = *src++;
+      dstsize--;
     }
   }
 
@@ -1693,11 +1697,12 @@ unquote_pathname(char       *dst,	// O - Destination string
                  const char *src,	// I - Source string
 	         int        dstsize)	// I - Size of destination string
 {
-  dstsize --;
+  dstsize--; // prepare for trailing zero
 
-  while (*src && dstsize > 1) {
-    if (*src == '\\') src ++;
+  while (*src && dstsize > 0) {
+    if (*src == '\\') src++;
     *dst++ = *src++;
+    dstsize--;
   }
 
   *dst = '\0';
